﻿using System;
using System.Threading;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Net.Sockets;
using System.Net;

namespace ledControl_4
{
  
    public partial class Form1 : Form
    {
        public bool connected_to_host = false;
        public Socket led_socket = null;

        public Form1()
        {
            InitializeComponent();
            
        }

        private void Form1_KeyUP(object sender, KeyEventArgs e)
        {
            // Determine whether the key entered is the F1 key. Display help if it is.
            if (e.KeyCode == Keys.L)
            {
                Globals.Lights = "X";
            }
            if (e.KeyCode == Keys.Up)
            {
                Globals.Forward = "X";
            }
            if (e.KeyCode == Keys.Down)
            {
                Globals.Backward = "X";               
            }
            if (e.KeyCode == Keys.Left)
            {
                Globals.Left = "X";              
            }
            if (e.KeyCode == Keys.Right)
            {
                Globals.Right = "X";             
            }


        }

        private void Form1_KeyDown(object sender, KeyEventArgs e)
        {
            if (connected_to_host)
            {

                if (e.KeyCode == Keys.L)
                {
                    Globals.Lights = "O";

                }
                if (e.KeyCode == Keys.Up)
                {
                    Globals.Forward = "F";
                    Globals.Backward = "X";
                }
                if (e.KeyCode == Keys.Down)
                {
                    Globals.Backward = "B";
                    Globals.Forward = "X";
                }
                if (e.KeyCode == Keys.Left)
                {
                    Globals.Left = "L";
                    Globals.Right = "X";
                }
                if (e.KeyCode == Keys.Right)
                {
                    Globals.Right = "R";
                    Globals.Left = "X";
                }

            }
            else
            {
                MessageBox.Show("Not Connected to Client");
            }

        }

        private void Form1_Load(object sender, EventArgs e)
        {
        
        }

        public void Connect_Button_Click(object sender, EventArgs e)
        {
            
            if (connected_to_host == false)
            {
                Connect_Button.Text = "Connect";

                string ip = IP_Address.Text;
                int port = Convert.ToInt32(Port.Text);

                Globals.led_socket = ConnectSocket(ip,port);

                Worker oWorker = new Worker();

                // Create the thread object, passing in the Alpha.Beta method
                // via a ThreadStart delegate. This does not start the thread.
                Globals.oThread = new Thread(new ThreadStart(oWorker.Beta));

                Globals.oThread.Start();


               if (Globals.led_socket != null)
               {
                   connected_to_host = true;
                   Connect_Button.Text = "Disconnect";

               }       
            }
            else
            {
                Connect_Button.Text = "Disconnect";
                Globals.led_socket.Close();
                Globals.oThread.Abort();
                connected_to_host = false;
                Connect_Button.Text = "Connect";

            }
        }

        private void ON_Click(object sender, EventArgs e)
        {
       
            Globals.Lights = "O";
        }

        private void OFF_Click(object sender, EventArgs e)
        {
         
            Globals.Lights = "X";
        
        }

        private static void SendCommand(Socket s, string c)
        {
            Byte[] command = Encoding.ASCII.GetBytes(c);
            try
            {
                s.Send(command, command.Length, 0);
            
            }catch(Exception Ex)
                {

                    Globals.oThread.Abort();
                
                    MessageBox.Show("Connection Aborted because it was already gone. I blame you.");


                }

        }


        public static Socket ConnectSocket(string server, int port)
        {
            Socket s = null;
            IPHostEntry hostEntry = null;

            // Get host related information.
            hostEntry = Dns.GetHostEntry(server);

            // Loop through the AddressList to obtain the supported AddressFamily. This is to avoid
            // an exception that occurs when the host IP Address is not compatible with the address family
            // (typical in the IPv6 case).
            foreach (IPAddress address in hostEntry.AddressList)
            {
                IPEndPoint ipe = new IPEndPoint(address, port);
                Socket tempSocket =
                    new Socket(ipe.AddressFamily, SocketType.Stream, ProtocolType.Tcp);

                try
                {
                    tempSocket.Connect(ipe);
                }
                catch (Exception Ex)
                {
                    MessageBox.Show("This is your fault, Make sure Car is Turned on.");
                }

                if (tempSocket.Connected)
                {
                    s = tempSocket;
                    break;
                }
                else
                {
                    continue;
                }
            }
            return s;
        }


        public class Worker
        {
            public void Beta()
            {
                while (true)
                {
                   //Console.WriteLine(Globals.Forward + Globals.Backward + Globals.Left + Globals.Right 
                   //     + Globals.Lights +"\n");

                    Form1.SendCommand(Globals.led_socket,Globals.Forward + Globals.Backward + Globals.Left + Globals.Right + Globals.Lights + "\n");
                
                }

            }
        };

        public class Globals
        {

            public static Socket led_socket;
            public static Thread oThread;
            
            public static string Lights = "X";
            public static string Temperature = "???";

            public static string Forward = "X";
            public static string Backward = "X";
            public static string Left = "X";
            public static string Right = "X";
        }

       
    }
}
